/**
    * @license
    * Copyright 2019 Google LLC. All Rights Reserved.
    * Licensed under the Apache License, Version 2.0 (the "License");
    * you may not use this file except in compliance with the License.
    * You may obtain a copy of the License at
    *
    * http://www.apache.org/licenses/LICENSE-2.0
    *
    * Unless required by applicable law or agreed to in writing, software
    * distributed under the License is distributed on an "AS IS" BASIS,
    * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    * See the License for the specific language governing permissions and
    * limitations under the License.
    * =============================================================================
    */
import{loadGraphModel}from"@tensorflow/tfjs-converter";import{util,tensor2d,tensor1d}from"@tensorflow/tfjs-core";function __awaiter(t,e,r,n){return new(r||(r=Promise))(function(o,i){function a(t){try{s(n.next(t))}catch(t){i(t)}}function l(t){try{s(n.throw(t))}catch(t){i(t)}}function s(t){t.done?o(t.value):new r(function(e){e(t.value)}).then(a,l)}s((n=n.apply(t,e||[])).next())})}function __generator(t,e){var r,n,o,i,a={label:0,sent:function(){if(1&o[0])throw o[1];return o[1]},trys:[],ops:[]};return i={next:l(0),throw:l(1),return:l(2)},"function"==typeof Symbol&&(i[Symbol.iterator]=function(){return this}),i;function l(i){return function(l){return function(i){if(r)throw new TypeError("Generator is already executing.");for(;a;)try{if(r=1,n&&(o=2&i[0]?n.return:i[0]?n.throw||((o=n.return)&&o.call(n),0):n.next)&&!(o=o.call(n,i[1])).done)return o;switch(n=0,o&&(i=[2&i[0],o.value]),i[0]){case 0:case 1:o=i;break;case 4:return a.label++,{value:i[1],done:!1};case 5:a.label++,n=i[1],i=[0];continue;case 7:i=a.ops.pop(),a.trys.pop();continue;default:if(!(o=(o=a.trys).length>0&&o[o.length-1])&&(6===i[0]||2===i[0])){a=0;continue}if(3===i[0]&&(!o||i[1]>o[0]&&i[1]<o[3])){a.label=i[1];break}if(6===i[0]&&a.label<o[1]){a.label=o[1],o=i;break}if(o&&a.label<o[2]){a.label=o[2],a.ops.push(i);break}o[2]&&a.ops.pop(),a.trys.pop();continue}i=e.call(t,a)}catch(t){i=[6,t],n=0}finally{r=o=0}if(5&i[0])throw i[1];return{value:i[0]?i[1]:void 0,done:!0}}([i,l])}}}function __awaiter$1(t,e,r,n){return new(r||(r=Promise))(function(o,i){function a(t){try{s(n.next(t))}catch(t){i(t)}}function l(t){try{s(n.throw(t))}catch(t){i(t)}}function s(t){t.done?o(t.value):new r(function(e){e(t.value)}).then(a,l)}s((n=n.apply(t,e||[])).next())})}function __generator$1(t,e){var r,n,o,i,a={label:0,sent:function(){if(1&o[0])throw o[1];return o[1]},trys:[],ops:[]};return i={next:l(0),throw:l(1),return:l(2)},"function"==typeof Symbol&&(i[Symbol.iterator]=function(){return this}),i;function l(i){return function(l){return function(i){if(r)throw new TypeError("Generator is already executing.");for(;a;)try{if(r=1,n&&(o=2&i[0]?n.return:i[0]?n.throw||((o=n.return)&&o.call(n),0):n.next)&&!(o=o.call(n,i[1])).done)return o;switch(n=0,o&&(i=[2&i[0],o.value]),i[0]){case 0:case 1:o=i;break;case 4:return a.label++,{value:i[1],done:!1};case 5:a.label++,n=i[1],i=[0];continue;case 7:i=a.ops.pop(),a.trys.pop();continue;default:if(!(o=(o=a.trys).length>0&&o[o.length-1])&&(6===i[0]||2===i[0])){a=0;continue}if(3===i[0]&&(!o||i[1]>o[0]&&i[1]<o[3])){a.label=i[1];break}if(6===i[0]&&a.label<o[1]){a.label=o[1],o=i;break}if(o&&a.label<o[2]){a.label=o[2],a.ops.push(i);break}o[2]&&a.ops.pop(),a.trys.pop();continue}i=e.call(t,a)}catch(t){i=[6,t],n=0}finally{r=o=0}if(5&i[0])throw i[1];return{value:i[0]?i[1]:void 0,done:!0}}([i,l])}}}var stringToChars=function(t){for(var e=[],r=0,n=t;r<n.length;r++){var o=n[r];e.push(o)}return e},TrieNode=function(){this.parent=null,this.children={},this.end=!1,this.word=[[],0,0]},Trie=function(){function t(){this.root=new TrieNode}return t.prototype.insert=function(t,e,r){for(var n=this.root,o=stringToChars(t),i=0;i<o.length;i++)n.children[o[i]]||(n.children[o[i]]=new TrieNode,n.children[o[i]].parent=n,n.children[o[i]].word[0]=n.word[0].concat(o[i])),n=n.children[o[i]],i===o.length-1&&(n.end=!0,n.word[1]=e,n.word[2]=r)},t.prototype.commonPrefixSearch=function(t){for(var e=[],r=this.root.children[t[0]],n=0;n<t.length&&r;n++)r.end&&e.push(r.word),r=r.children[t[n+1]];return e.length||e.push([[t[0]],0,0]),e},t}(),separator="▁";function processInput(t){var e=t.normalize("NFKC");return separator+e.replace(/ /g,separator)}var RESERVED_SYMBOLS_COUNT=6,Tokenizer=function(){function t(t){this.vocabulary=t,this.trie=new Trie;for(var e=RESERVED_SYMBOLS_COUNT;e<this.vocabulary.length;e++)this.trie.insert(this.vocabulary[e][0],this.vocabulary[e][1],e)}return t.prototype.encode=function(t){var e=[],r=[],n=[];t=processInput(t);for(var o=stringToChars(t),i=0;i<=o.length;i++)e.push({}),r.push(0),n.push(0);for(i=0;i<o.length;i++)for(var a=this.trie.commonPrefixSearch(o.slice(i)),l=0;l<a.length;l++){var s=a[l],u={key:s[0],score:s[1],index:s[2]};null==e[i+(c=s[0].length)][i]&&(e[i+c][i]=[]),e[i+c][i].push(u)}for(var c=0;c<=o.length;c++)for(var h in e[c]){var f=e[c][h];for(l=0;l<f.length;l++){var d=f[l],p=d.score+n[c-d.key.length];(0===n[c]||p>=n[c])&&(n[c]=p,r[c]=f[l].index)}}for(var v=[],y=r.length-1;y>0;)v.push(r[y]),y-=this.vocabulary[r[y]][0].length;var b=[],w=!1;for(i=0;i<v.length;i++){var g=v[i];w&&0===g||b.push(g),w=0===g}return b.reverse()},t}(),BASE_PATH="https://storage.googleapis.com/tfjs-models/savedmodel/universal_sentence_encoder/";function loadTokenizer(t){return __awaiter$1(this,void 0,void 0,function(){var e;return __generator$1(this,function(r){switch(r.label){case 0:return[4,loadVocabulary(t)];case 1:return e=r.sent(),[2,new Tokenizer(e)]}})})}function loadVocabulary(t){return void 0===t&&(t=BASE_PATH+"vocab.json"),__awaiter$1(this,void 0,void 0,function(){return __generator$1(this,function(e){switch(e.label){case 0:return[4,util.fetch(t)];case 1:return[2,e.sent().json()]}})})}var version$1="1.2.2";function load$1(t,e){return __awaiter(this,void 0,void 0,function(){var r;return __generator(this,function(n){switch(n.label){case 0:return[4,(r=new ToxicityClassifier(t,e)).load()];case 1:return n.sent(),[2,r]}})})}var ToxicityClassifier=function(){function t(t,e){void 0===t&&(t=.85),void 0===e&&(e=[]),this.threshold=t,this.toxicityLabels=e}return t.prototype.loadModel=function(){return __awaiter(this,void 0,void 0,function(){return __generator(this,function(t){return[2,loadGraphModel("https://tfhub.dev/tensorflow/tfjs-model/toxicity/1/default/1",{fromTFHub:!0})]})})},t.prototype.loadTokenizer=function(){return __awaiter(this,void 0,void 0,function(){return __generator(this,function(t){return[2,loadTokenizer()]})})},t.prototype.load=function(){return __awaiter(this,void 0,void 0,function(){var t,e,r,n=this;return __generator(this,function(o){switch(o.label){case 0:return[4,Promise.all([this.loadModel(),this.loadTokenizer()])];case 1:return t=o.sent(),e=t[0],r=t[1],this.model=e,this.tokenizer=r,this.labels=e.outputs.map(function(t){return t.name.split("/")[0]}),0===this.toxicityLabels.length?this.toxicityLabels=this.labels:util.assert(this.toxicityLabels.every(function(t){return n.labels.indexOf(t)>-1}),function(){return"toxicityLabels argument must contain only items from the model heads "+n.labels.join(", ")+", got "+n.toxicityLabels.join(", ")}),[2]}})})},t.prototype.classify=function(t){return __awaiter(this,void 0,void 0,function(){var e,r,n,o,i,a,l,s=this;return __generator(this,function(u){switch(u.label){case 0:for("string"==typeof t&&(t=[t]),e=t.map(function(t){return s.tokenizer.encode(t)}),r=e.map(function(t,e){return t.map(function(t,r){return[e,r]})}),n=[],o=0;o<r.length;o++)n=n.concat(r[o]);return i=tensor2d(n,[n.length,2],"int32"),a=tensor1d(util.flatten(e),"int32"),[4,this.model.executeAsync({Placeholder_1:i,Placeholder:a})];case 1:return l=u.sent(),i.dispose(),a.dispose(),[2,l.map(function(t,e){return{data:t,headIndex:e}}).filter(function(t){return s.toxicityLabels.indexOf(s.labels[t.headIndex])>-1}).map(function(e){for(var r=e.data.dataSync(),n=[],o=0;o<t.length;o++){var i=r.slice(2*o,2*o+2),a=null;Math.max(i[0],i[1])>s.threshold&&(a=i[0]<i[1]),n.push({probabilities:i,match:a})}return{label:s.labels[e.headIndex],results:n}})]}})})},t}();export{load$1 as load,ToxicityClassifier,version$1 as version};
